|
|	l_support.sa 1.2 5/1/91
|
|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

L_SUPPORT:    |idnt    2,1 ; Motorola 040 Floating Point Software Package

	|section    8

mns_one:  .long 0xbfff0000,0x80000000,0x00000000
pls_one:  .long 0x3fff0000,0x80000000,0x00000000
pls_inf:  .long 0x7fff0000,0x00000000,0x00000000
pls_huge: .long 0x7ffe0000,0xffffffff,0xffffffff
mns_huge: .long 0xfffe0000,0xffffffff,0xffffffff
pls_tiny: .long 0x00000000,0x80000000,0x00000000
mns_tiny: .long 0x80000000,0x80000000,0x00000000
small:    .long 0x20000000,0x80000000,0x00000000
pls_zero: .long 0x00000000,0x00000000,0x00000000

	.include "l_fpsp.h"

|
| 	tag --- determine the type of an extended precision operand
|
|	The tag values returned match the way the 68040 would have
|	tagged them.
|
|	Input:	a0 points to operand
|
|	Output	d0.b	= $00 norm
|			  $20 zero
|			  $40 inf
|			  $60 nan
|			  $80 denorm
|		All other registers are unchanged
|
	.globl	tag
tag:
	movew	a0@(LOCAL_EX),d0
	andiw	#0x7fff,d0
	jeq	chk_zro
	cmpiw	#0x7fff,d0
	jeq	chk_inf
tag_nrm:
	clrb	d0
	rts
tag_nan:
	moveb	#0x60,d0
	rts
tag_dnrm:
	moveb	#0x80,d0
	rts
chk_zro:
	btst	#7,a0@(LOCAL_HI)	| # check if J-bit is set
	jne	tag_nrm
	tstl	a0@(LOCAL_HI)
	jne	tag_dnrm
	tstl	a0@(LOCAL_LO)
	jne	tag_dnrm
tag_zero:
	moveb	#0x20,d0
	rts
chk_inf:
	tstl	a0@(LOCAL_HI)
	jne	tag_nan
	tstl	a0@(LOCAL_LO)
	jne	tag_nan
tag_inf:
	moveb	#0x40,d0
	rts

|
|	t_dz, t_dz2 --- divide by zero exception
|
| t_dz2 is used by monadic functions such as flogn (from do_func).
| t_dz is used by monadic functions such as satanh (from the 
| transcendental function).
|
	.globl    t_dz2
t_dz2:
	fmovemx	mns_one,fp0-fp0
	fmovel	d1,fpcr
	fdivx		pls_zero,fp0
	rts

	.globl	t_dz
t_dz:
	btst	#sign_bit,a6@(ETEMP_EX)	|check sign for neg or pos
	jeq	p_inf			|branch if pos sign
m_inf:
	fmovemx mns_one,fp0-fp0
	fmovel	d1,fpcr
	fdivx		pls_zero,fp0
	rts
p_inf:
	fmovemx pls_one,fp0-fp0
	fmovel	d1,fpcr
	fdivx		pls_zero,fp0
	rts
|
|	t_operr --- Operand Error exception
|
	.globl    t_operr
t_operr:
	fmovemx	pls_inf,fp0-fp0
	fmovel	d1,fpcr
	fmulx		pls_zero,fp0
	rts

|
|	t_unfl --- UNFL exception
|
	.globl    t_unfl
t_unfl:
	btst	#sign_bit,a6@(ETEMP)
	jeq	unf_pos
unf_neg:
	fmovemx	mns_tiny,fp0-fp0
	fmovel	d1,fpcr
	fmulx	pls_tiny,fp0
	rts
	
unf_pos:
	fmovemx	pls_tiny,fp0-fp0
	fmovel	d1,fpcr
	fmulx	fp0,fp0
	rts
|
|	t_ovfl --- OVFL exception
|
|	t_ovfl is called as an exit for monadic functions.  t_ovfl2
|	is for dyadic exits.
|
	.globl   		t_ovfl
t_ovfl:
	.globl   		t_ovfl2
	movel		d1,a6@(USER_FPCR)	| user's control register
	movel		#ovfinx_mask,d0
	jra		t_work
t_ovfl2:
	movel		#ovfl_inx_mask,d0
t_work:
	btst		#sign_bit,a6@(ETEMP)
	jeq		ovf_pos
ovf_neg:
	fmovemx	mns_huge,fp0-fp0
	fmovel		a6@(USER_FPCR),fpcr
	fmulx		pls_huge,fp0
	fmovel		fpsr,d1
	orl		d1,d0
	fmovel		d0,fpsr
	rts
ovf_pos:
	fmovemx	pls_huge,fp0-fp0
	fmovel		a6@(USER_FPCR),fpcr
	fmulx		pls_huge,fp0
	fmovel		fpsr,d1
	orl		d1,d0
	fmovel		d0,fpsr
	rts
|
|	t_inx2 --- INEX2 exception (correct fpcr is in USER_FPCR(a6))
|
	.globl    t_inx2
t_inx2:
	fmovel		fpsr,a6@(USER_FPSR)	| capture incoming fpsr
	fmovel		a6@(USER_FPCR),fpcr
|
| create an inex2 exception by adding two numbers with very different exponents
| do the add in fp1 so as to not disturb the result sitting in fp0
|
	fmovex		pls_one,fp1
	faddx		small,fp1
|
	orl	#inx2a_mask,a6@(USER_FPSR) |set INEX2, AINEX
	fmovel	a6@(USER_FPSR),fpsr
	rts
|
|	t_frcinx --- Force Inex2 (for monadic functions)
|
	.globl	t_frcinx
t_frcinx:
	fmovel		fpsr,a6@(USER_FPSR)	| capture incoming fpsr
	fmovel		d1,fpcr
|
| create an inex2 exception by adding two numbers with very different exponents
| do the add in fp1 so as to not disturb the result sitting in fp0
|
| BUG FIX -- W. Eric Norum -- Saskatchewan Accelerator Laboratory -- 27-SEP-93
| Do the add in fp2 since fp1 may also contain a result (e.g. for sincos)
|
	fmovex		pls_one,fp2
	faddx		small,fp2
|
	orl	#inx2a_mask,a6@(USER_FPSR) |set INEX2, AINEX
	btst	#unfl_bit,a6@(FPSR_EXCEPT) |test for unfl bit set
	jeq	no_uacc1		|if clear, do not set aunfl
	bset	#aunfl_bit,a6@(FPSR_AEXCEPT)
no_uacc1:
	fmovel	a6@(USER_FPSR),fpsr
	rts
|
|	dst_nan --- force result when destination is a NaN
|
	.globl	dst_nan
dst_nan:
	fmovel	a6@(USER_FPCR),fpcr
	fmovex a6@(FPTEMP),fp0
	rts

|
|	src_nan --- force result when source is a NaN
|
	.globl	src_nan
src_nan:
	fmovel	a6@(USER_FPCR),fpcr
	fmovex	a6@(ETEMP),fp0
	rts
|
|	mon_nan --- force result when source is a NaN (monadic version)
|
|	This is the same as src_nan except that the user's fpcr comes
|	in via d1, not USER_FPCR(a6).
|
	.globl	mon_nan
mon_nan:
	fmovel	d1,fpcr
	fmovex	a6@(ETEMP),fp0
	rts
|
|	t_extdnrm, t_resdnrm --- generate results for denorm inputs
|
|	For all functions that have a denormalized input and that f(x)=x,
|	this is the entry point.
|
	.globl	t_extdnrm
t_extdnrm:
	fmovel	d1,fpcr
	fmovex	a0@(LOCAL_EX),fp0
	fmovel		fpsr,d0
	orl		#unfinx_mask,d0
	fmovel		d0,fpsr
	rts

	.globl	t_resdnrm
t_resdnrm:
	fmovel	a6@(USER_FPCR),fpcr
	fmovex	a0@(LOCAL_EX),fp0
	fmovel		fpsr,d0
	orl		#unfl_mask,d0
	fmovel		d0,fpsr
	rts
|
|
|
	.globl	t_avoid_unsupp
t_avoid_unsupp:
	fmovex	fp0,fp0
	rts

	.globl	sto_cos
sto_cos:
	fmovemx a0@(LOCAL_EX),fp1-fp1
	rts
|
|	Native instruction support
|
|	Some systems may need entry points even for 68040 native
|	instructions.  These routines are provided for
|	convenience.
|
	.globl	sadd
sadd:
	fmovemx	a6@(FPTEMP),fp0-fp0
	fmovel	a6@(USER_FPCR),fpcr
	faddx	a6@(ETEMP),fp0
	rts

	.globl	ssub
ssub:
	fmovemx	a6@(FPTEMP),fp0-fp0
	fmovel	a6@(USER_FPCR),fpcr
	fsubx	a6@(ETEMP),fp0
	rts

	.globl	smul
smul:
	fmovemx	a6@(FPTEMP),fp0-fp0
	fmovel	a6@(USER_FPCR),fpcr
	fmulx	a6@(ETEMP),fp0
	rts

	.globl	sdiv
sdiv:
	fmovemx	a6@(FPTEMP),fp0-fp0
	fmovel	a6@(USER_FPCR),fpcr
	fdivx	a6@(ETEMP),fp0
	rts

	.globl	sabs
sabs:
	fmovemx	a6@(ETEMP),fp0-fp0
	fmovel	d1,fpcr
	fabsx	fp0
	rts

	.globl	sneg
sneg:
	fmovemx	a6@(ETEMP),fp0-fp0
	fmovel	d1,fpcr
	fnegx	fp0
	rts

	.globl	ssqrt
ssqrt:
	fmovemx	a6@(ETEMP),fp0-fp0
	fmovel	d1,fpcr
	fsqrtx	fp0
	rts

|
|	l_sint,l_sintrz,l_sintd --- special wrapper for fint and fintrz
|
|	On entry, move the user's FPCR to USER_FPCR.
|
|	On return from, we need to pickup the INEX2/AINEX bits
|	that are in USER_FPSR.
|
	|xref	sint
	|xref	sintrz
	|xref	sintd

	.globl	l_sint
l_sint:
	movel	d1,a6@(USER_FPCR)
	jsr	sint
	fmovel	fpsr,d0
	orl	a6@(USER_FPSR),d0
	fmovel	d0,fpsr
	rts

	.globl	l_sintrz
l_sintrz:
	movel	d1,a6@(USER_FPCR)
	jsr	sintrz
	fmovel	fpsr,d0
	orl	a6@(USER_FPSR),d0
	fmovel	d0,fpsr
	rts

	.globl	l_sintd
l_sintd:
	movel	d1,a6@(USER_FPCR)
	jsr	sintd
	fmovel	fpsr,d0
	orl	a6@(USER_FPSR),d0
	fmovel	d0,fpsr
	rts

	|end
