	|section 8
	.include "l_fpsp.h"

	|xref	tag
	|xref	szero
	|xref	sinf
	|xref	sopr_inf
	|xref	sone
	|xref	spi_2
	|xref	szr_inf
	|xref	src_nan
	|xref	t_operr
	|xref	t_dz2
	|xref	snzrinx
	|xref	ld_pone
	|xref	ld_pinf
	|xref	ld_ppi2
	|xref	ssincosz
	|xref	ssincosi
	|xref	ssincosnan
	|xref	setoxm1i
|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the facoss and facosx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	sacos
	|xref	ld_ppi2
	|xref	t_operr
	|xref	mon_nan
	|xref	sacosd

	.globl	facoss
facoss:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1012
	jbsr	sacos		| normalized (regular) number
	jra	L_1016
L_1012:
	cmpb	#0x20,d0		| zero?
	jne	L_1013
	jbsr	ld_ppi2
	jra	L_1016
L_1013:
	cmpb	#0x40,d0		| infinity?
	jne	L_1014
	jbsr	t_operr
	jra	L_1016
L_1014:
	cmpb	#0x60,d0		| NaN?
	jne	L_1015
	jbsr	mon_nan
	jra	L_1016
L_1015:
	jbsr	sacosd		| assuming a denorm...

L_1016:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	facosd
facosd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1017
	jbsr	sacos		| normalized (regular) number
	jra	L_101B
L_1017:
	cmpb	#0x20,d0		| zero?
	jne	L_1018
	jbsr	ld_ppi2
	jra	L_101B
L_1018:
	cmpb	#0x40,d0		| infinity?
	jne	L_1019
	jbsr	t_operr
	jra	L_101B
L_1019:
	cmpb	#0x60,d0		| NaN?
	jne	L_101A
	jbsr	mon_nan
	jra	L_101B
L_101A:
	jbsr	sacosd		| assuming a denorm...

L_101B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	facosx
facosx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_101C
	jbsr	sacos		| normalized (regular) number
	jra	L_101G
L_101C:
	cmpb	#0x20,d0		| zero?
	jne	L_101D
	jbsr	ld_ppi2
	jra	L_101G
L_101D:
	cmpb	#0x40,d0		| infinity?
	jne	L_101E
	jbsr	t_operr
	jra	L_101G
L_101E:
	cmpb	#0x60,d0		| NaN?
	jne	L_101F
	jbsr	mon_nan
	jra	L_101G
L_101F:
	jbsr	sacosd		| assuming a denorm...

L_101G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fasins and fasinx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	sasin
	|xref	szero
	|xref	t_operr
	|xref	mon_nan
	|xref	sasind

	.globl	fasins
fasins:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1022
	jbsr	sasin		| normalized (regular) number
	jra	L_1026
L_1022:
	cmpb	#0x20,d0		| zero?
	jne	L_1023
	jbsr	szero
	jra	L_1026
L_1023:
	cmpb	#0x40,d0		| infinity?
	jne	L_1024
	jbsr	t_operr
	jra	L_1026
L_1024:
	cmpb	#0x60,d0		| NaN?
	jne	L_1025
	jbsr	mon_nan
	jra	L_1026
L_1025:
	jbsr	sasind		| assuming a denorm...

L_1026:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fasind
fasind:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1027
	jbsr	sasin		| normalized (regular) number
	jra	L_102B
L_1027:
	cmpb	#0x20,d0		| zero?
	jne	L_1028
	jbsr	szero
	jra	L_102B
L_1028:
	cmpb	#0x40,d0		| infinity?
	jne	L_1029
	jbsr	t_operr
	jra	L_102B
L_1029:
	cmpb	#0x60,d0		| NaN?
	jne	L_102A
	jbsr	mon_nan
	jra	L_102B
L_102A:
	jbsr	sasind		| assuming a denorm...

L_102B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fasinx
fasinx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_102C
	jbsr	sasin		| normalized (regular) number
	jra	L_102G
L_102C:
	cmpb	#0x20,d0		| zero?
	jne	L_102D
	jbsr	szero
	jra	L_102G
L_102D:
	cmpb	#0x40,d0		| infinity?
	jne	L_102E
	jbsr	t_operr
	jra	L_102G
L_102E:
	cmpb	#0x60,d0		| NaN?
	jne	L_102F
	jbsr	mon_nan
	jra	L_102G
L_102F:
	jbsr	sasind		| assuming a denorm...

L_102G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fatans and fatanx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	satan
	|xref	szero
	|xref	spi_2
	|xref	mon_nan
	|xref	satand

	.globl	fatans
fatans:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1032
	jbsr	satan		| normalized (regular) number
	jra	L_1036
L_1032:
	cmpb	#0x20,d0		| zero?
	jne	L_1033
	jbsr	szero
	jra	L_1036
L_1033:
	cmpb	#0x40,d0		| infinity?
	jne	L_1034
	jbsr	spi_2
	jra	L_1036
L_1034:
	cmpb	#0x60,d0		| NaN?
	jne	L_1035
	jbsr	mon_nan
	jra	L_1036
L_1035:
	jbsr	satand		| assuming a denorm...

L_1036:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fatand
fatand:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1037
	jbsr	satan		| normalized (regular) number
	jra	L_103B
L_1037:
	cmpb	#0x20,d0		| zero?
	jne	L_1038
	jbsr	szero
	jra	L_103B
L_1038:
	cmpb	#0x40,d0		| infinity?
	jne	L_1039
	jbsr	spi_2
	jra	L_103B
L_1039:
	cmpb	#0x60,d0		| NaN?
	jne	L_103A
	jbsr	mon_nan
	jra	L_103B
L_103A:
	jbsr	satand		| assuming a denorm...

L_103B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fatanx
fatanx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_103C
	jbsr	satan		| normalized (regular) number
	jra	L_103G
L_103C:
	cmpb	#0x20,d0		| zero?
	jne	L_103D
	jbsr	szero
	jra	L_103G
L_103D:
	cmpb	#0x40,d0		| infinity?
	jne	L_103E
	jbsr	spi_2
	jra	L_103G
L_103E:
	cmpb	#0x60,d0		| NaN?
	jne	L_103F
	jbsr	mon_nan
	jra	L_103G
L_103F:
	jbsr	satand		| assuming a denorm...

L_103G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fatanhs and fatanhx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	satanh
	|xref	szero
	|xref	t_operr
	|xref	mon_nan
	|xref	satanhd

	.globl	fatanhs
fatanhs:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1042
	jbsr	satanh		| normalized (regular) number
	jra	L_1046
L_1042:
	cmpb	#0x20,d0		| zero?
	jne	L_1043
	jbsr	szero
	jra	L_1046
L_1043:
	cmpb	#0x40,d0		| infinity?
	jne	L_1044
	jbsr	t_operr
	jra	L_1046
L_1044:
	cmpb	#0x60,d0		| NaN?
	jne	L_1045
	jbsr	mon_nan
	jra	L_1046
L_1045:
	jbsr	satanhd		| assuming a denorm...

L_1046:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fatanhd
fatanhd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1047
	jbsr	satanh		| normalized (regular) number
	jra	L_104B
L_1047:
	cmpb	#0x20,d0		| zero?
	jne	L_1048
	jbsr	szero
	jra	L_104B
L_1048:
	cmpb	#0x40,d0		| infinity?
	jne	L_1049
	jbsr	t_operr
	jra	L_104B
L_1049:
	cmpb	#0x60,d0		| NaN?
	jne	L_104A
	jbsr	mon_nan
	jra	L_104B
L_104A:
	jbsr	satanhd		| assuming a denorm...

L_104B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fatanhx
fatanhx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_104C
	jbsr	satanh		| normalized (regular) number
	jra	L_104G
L_104C:
	cmpb	#0x20,d0		| zero?
	jne	L_104D
	jbsr	szero
	jra	L_104G
L_104D:
	cmpb	#0x40,d0		| infinity?
	jne	L_104E
	jbsr	t_operr
	jra	L_104G
L_104E:
	cmpb	#0x60,d0		| NaN?
	jne	L_104F
	jbsr	mon_nan
	jra	L_104G
L_104F:
	jbsr	satanhd		| assuming a denorm...

L_104G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fcoss and fcosx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	scos
	|xref	ld_pone
	|xref	t_operr
	|xref	mon_nan
	|xref	scosd

	.globl	fcoss
fcoss:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1052
	jbsr	scos		| normalized (regular) number
	jra	L_1056
L_1052:
	cmpb	#0x20,d0		| zero?
	jne	L_1053
	jbsr	ld_pone
	jra	L_1056
L_1053:
	cmpb	#0x40,d0		| infinity?
	jne	L_1054
	jbsr	t_operr
	jra	L_1056
L_1054:
	cmpb	#0x60,d0		| NaN?
	jne	L_1055
	jbsr	mon_nan
	jra	L_1056
L_1055:
	jbsr	scosd		| assuming a denorm...

L_1056:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fcosd
fcosd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1057
	jbsr	scos		| normalized (regular) number
	jra	L_105B
L_1057:
	cmpb	#0x20,d0		| zero?
	jne	L_1058
	jbsr	ld_pone
	jra	L_105B
L_1058:
	cmpb	#0x40,d0		| infinity?
	jne	L_1059
	jbsr	t_operr
	jra	L_105B
L_1059:
	cmpb	#0x60,d0		| NaN?
	jne	L_105A
	jbsr	mon_nan
	jra	L_105B
L_105A:
	jbsr	scosd		| assuming a denorm...

L_105B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fcosx
fcosx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_105C
	jbsr	scos		| normalized (regular) number
	jra	L_105G
L_105C:
	cmpb	#0x20,d0		| zero?
	jne	L_105D
	jbsr	ld_pone
	jra	L_105G
L_105D:
	cmpb	#0x40,d0		| infinity?
	jne	L_105E
	jbsr	t_operr
	jra	L_105G
L_105E:
	cmpb	#0x60,d0		| NaN?
	jne	L_105F
	jbsr	mon_nan
	jra	L_105G
L_105F:
	jbsr	scosd		| assuming a denorm...

L_105G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fcoshs and fcoshx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	scosh
	|xref	ld_pone
	|xref	ld_pinf
	|xref	mon_nan
	|xref	scoshd

	.globl	fcoshs
fcoshs:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1062
	jbsr	scosh		| normalized (regular) number
	jra	L_1066
L_1062:
	cmpb	#0x20,d0		| zero?
	jne	L_1063
	jbsr	ld_pone
	jra	L_1066
L_1063:
	cmpb	#0x40,d0		| infinity?
	jne	L_1064
	jbsr	ld_pinf
	jra	L_1066
L_1064:
	cmpb	#0x60,d0		| NaN?
	jne	L_1065
	jbsr	mon_nan
	jra	L_1066
L_1065:
	jbsr	scoshd		| assuming a denorm...

L_1066:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fcoshd
fcoshd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1067
	jbsr	scosh		| normalized (regular) number
	jra	L_106B
L_1067:
	cmpb	#0x20,d0		| zero?
	jne	L_1068
	jbsr	ld_pone
	jra	L_106B
L_1068:
	cmpb	#0x40,d0		| infinity?
	jne	L_1069
	jbsr	ld_pinf
	jra	L_106B
L_1069:
	cmpb	#0x60,d0		| NaN?
	jne	L_106A
	jbsr	mon_nan
	jra	L_106B
L_106A:
	jbsr	scoshd		| assuming a denorm...

L_106B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fcoshx
fcoshx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_106C
	jbsr	scosh		| normalized (regular) number
	jra	L_106G
L_106C:
	cmpb	#0x20,d0		| zero?
	jne	L_106D
	jbsr	ld_pone
	jra	L_106G
L_106D:
	cmpb	#0x40,d0		| infinity?
	jne	L_106E
	jbsr	ld_pinf
	jra	L_106G
L_106E:
	cmpb	#0x60,d0		| NaN?
	jne	L_106F
	jbsr	mon_nan
	jra	L_106G
L_106F:
	jbsr	scoshd		| assuming a denorm...

L_106G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fetoxs and fetoxx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	setox
	|xref	ld_pone
	|xref	szr_inf
	|xref	mon_nan
	|xref	setoxd

	.globl	fetoxs
fetoxs:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1072
	jbsr	setox		| normalized (regular) number
	jra	L_1076
L_1072:
	cmpb	#0x20,d0		| zero?
	jne	L_1073
	jbsr	ld_pone
	jra	L_1076
L_1073:
	cmpb	#0x40,d0		| infinity?
	jne	L_1074
	jbsr	szr_inf
	jra	L_1076
L_1074:
	cmpb	#0x60,d0		| NaN?
	jne	L_1075
	jbsr	mon_nan
	jra	L_1076
L_1075:
	jbsr	setoxd		| assuming a denorm...

L_1076:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fetoxd
fetoxd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1077
	jbsr	setox		| normalized (regular) number
	jra	L_107B
L_1077:
	cmpb	#0x20,d0		| zero?
	jne	L_1078
	jbsr	ld_pone
	jra	L_107B
L_1078:
	cmpb	#0x40,d0		| infinity?
	jne	L_1079
	jbsr	szr_inf
	jra	L_107B
L_1079:
	cmpb	#0x60,d0		| NaN?
	jne	L_107A
	jbsr	mon_nan
	jra	L_107B
L_107A:
	jbsr	setoxd		| assuming a denorm...

L_107B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fetoxx
fetoxx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_107C
	jbsr	setox		| normalized (regular) number
	jra	L_107G
L_107C:
	cmpb	#0x20,d0		| zero?
	jne	L_107D
	jbsr	ld_pone
	jra	L_107G
L_107D:
	cmpb	#0x40,d0		| infinity?
	jne	L_107E
	jbsr	szr_inf
	jra	L_107G
L_107E:
	cmpb	#0x60,d0		| NaN?
	jne	L_107F
	jbsr	mon_nan
	jra	L_107G
L_107F:
	jbsr	setoxd		| assuming a denorm...

L_107G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fetoxm1s and fetoxm1x entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	setoxm1
	|xref	szero
	|xref	setoxm1i
	|xref	mon_nan
	|xref	setoxm1d

	.globl	fetoxm1s
fetoxm1s:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1082
	jbsr	setoxm1		| normalized (regular) number
	jra	L_1086
L_1082:
	cmpb	#0x20,d0		| zero?
	jne	L_1083
	jbsr	szero
	jra	L_1086
L_1083:
	cmpb	#0x40,d0		| infinity?
	jne	L_1084
	jbsr	setoxm1i
	jra	L_1086
L_1084:
	cmpb	#0x60,d0		| NaN?
	jne	L_1085
	jbsr	mon_nan
	jra	L_1086
L_1085:
	jbsr	setoxm1d		| assuming a denorm...

L_1086:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fetoxm1d
fetoxm1d:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1087
	jbsr	setoxm1		| normalized (regular) number
	jra	L_108B
L_1087:
	cmpb	#0x20,d0		| zero?
	jne	L_1088
	jbsr	szero
	jra	L_108B
L_1088:
	cmpb	#0x40,d0		| infinity?
	jne	L_1089
	jbsr	setoxm1i
	jra	L_108B
L_1089:
	cmpb	#0x60,d0		| NaN?
	jne	L_108A
	jbsr	mon_nan
	jra	L_108B
L_108A:
	jbsr	setoxm1d		| assuming a denorm...

L_108B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fetoxm1x
fetoxm1x:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_108C
	jbsr	setoxm1		| normalized (regular) number
	jra	L_108G
L_108C:
	cmpb	#0x20,d0		| zero?
	jne	L_108D
	jbsr	szero
	jra	L_108G
L_108D:
	cmpb	#0x40,d0		| infinity?
	jne	L_108E
	jbsr	setoxm1i
	jra	L_108G
L_108E:
	cmpb	#0x60,d0		| NaN?
	jne	L_108F
	jbsr	mon_nan
	jra	L_108G
L_108F:
	jbsr	setoxm1d		| assuming a denorm...

L_108G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fgetexps and fgetexpx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	sgetexp
	|xref	szero
	|xref	t_operr
	|xref	mon_nan
	|xref	sgetexpd

	.globl	fgetexps
fgetexps:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1092
	jbsr	sgetexp		| normalized (regular) number
	jra	L_1096
L_1092:
	cmpb	#0x20,d0		| zero?
	jne	L_1093
	jbsr	szero
	jra	L_1096
L_1093:
	cmpb	#0x40,d0		| infinity?
	jne	L_1094
	jbsr	t_operr
	jra	L_1096
L_1094:
	cmpb	#0x60,d0		| NaN?
	jne	L_1095
	jbsr	mon_nan
	jra	L_1096
L_1095:
	jbsr	sgetexpd		| assuming a denorm...

L_1096:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fgetexpd
fgetexpd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1097
	jbsr	sgetexp		| normalized (regular) number
	jra	L_109B
L_1097:
	cmpb	#0x20,d0		| zero?
	jne	L_1098
	jbsr	szero
	jra	L_109B
L_1098:
	cmpb	#0x40,d0		| infinity?
	jne	L_1099
	jbsr	t_operr
	jra	L_109B
L_1099:
	cmpb	#0x60,d0		| NaN?
	jne	L_109A
	jbsr	mon_nan
	jra	L_109B
L_109A:
	jbsr	sgetexpd		| assuming a denorm...

L_109B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fgetexpx
fgetexpx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_109C
	jbsr	sgetexp		| normalized (regular) number
	jra	L_109G
L_109C:
	cmpb	#0x20,d0		| zero?
	jne	L_109D
	jbsr	szero
	jra	L_109G
L_109D:
	cmpb	#0x40,d0		| infinity?
	jne	L_109E
	jbsr	t_operr
	jra	L_109G
L_109E:
	cmpb	#0x60,d0		| NaN?
	jne	L_109F
	jbsr	mon_nan
	jra	L_109G
L_109F:
	jbsr	sgetexpd		| assuming a denorm...

L_109G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fsins and fsinx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	ssin
	|xref	szero
	|xref	t_operr
	|xref	mon_nan
	|xref	ssind

	.globl	fsins
fsins:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1102
	jbsr	ssin		| normalized (regular) number
	jra	L_1106
L_1102:
	cmpb	#0x20,d0		| zero?
	jne	L_1103
	jbsr	szero
	jra	L_1106
L_1103:
	cmpb	#0x40,d0		| infinity?
	jne	L_1104
	jbsr	t_operr
	jra	L_1106
L_1104:
	cmpb	#0x60,d0		| NaN?
	jne	L_1105
	jbsr	mon_nan
	jra	L_1106
L_1105:
	jbsr	ssind		| assuming a denorm...

L_1106:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fsind
fsind:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1107
	jbsr	ssin		| normalized (regular) number
	jra	L_110B
L_1107:
	cmpb	#0x20,d0		| zero?
	jne	L_1108
	jbsr	szero
	jra	L_110B
L_1108:
	cmpb	#0x40,d0		| infinity?
	jne	L_1109
	jbsr	t_operr
	jra	L_110B
L_1109:
	cmpb	#0x60,d0		| NaN?
	jne	L_110A
	jbsr	mon_nan
	jra	L_110B
L_110A:
	jbsr	ssind		| assuming a denorm...

L_110B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fsinx
fsinx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_110C
	jbsr	ssin		| normalized (regular) number
	jra	L_110G
L_110C:
	cmpb	#0x20,d0		| zero?
	jne	L_110D
	jbsr	szero
	jra	L_110G
L_110D:
	cmpb	#0x40,d0		| infinity?
	jne	L_110E
	jbsr	t_operr
	jra	L_110G
L_110E:
	cmpb	#0x60,d0		| NaN?
	jne	L_110F
	jbsr	mon_nan
	jra	L_110G
L_110F:
	jbsr	ssind		| assuming a denorm...

L_110G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fsinhs and fsinhx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	ssinh
	|xref	szero
	|xref	sinf
	|xref	mon_nan
	|xref	ssinhd

	.globl	fsinhs
fsinhs:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1112
	jbsr	ssinh		| normalized (regular) number
	jra	L_1116
L_1112:
	cmpb	#0x20,d0		| zero?
	jne	L_1113
	jbsr	szero
	jra	L_1116
L_1113:
	cmpb	#0x40,d0		| infinity?
	jne	L_1114
	jbsr	sinf
	jra	L_1116
L_1114:
	cmpb	#0x60,d0		| NaN?
	jne	L_1115
	jbsr	mon_nan
	jra	L_1116
L_1115:
	jbsr	ssinhd		| assuming a denorm...

L_1116:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fsinhd
fsinhd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1117
	jbsr	ssinh		| normalized (regular) number
	jra	L_111B
L_1117:
	cmpb	#0x20,d0		| zero?
	jne	L_1118
	jbsr	szero
	jra	L_111B
L_1118:
	cmpb	#0x40,d0		| infinity?
	jne	L_1119
	jbsr	sinf
	jra	L_111B
L_1119:
	cmpb	#0x60,d0		| NaN?
	jne	L_111A
	jbsr	mon_nan
	jra	L_111B
L_111A:
	jbsr	ssinhd		| assuming a denorm...

L_111B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fsinhx
fsinhx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_111C
	jbsr	ssinh		| normalized (regular) number
	jra	L_111G
L_111C:
	cmpb	#0x20,d0		| zero?
	jne	L_111D
	jbsr	szero
	jra	L_111G
L_111D:
	cmpb	#0x40,d0		| infinity?
	jne	L_111E
	jbsr	sinf
	jra	L_111G
L_111E:
	cmpb	#0x60,d0		| NaN?
	jne	L_111F
	jbsr	mon_nan
	jra	L_111G
L_111F:
	jbsr	ssinhd		| assuming a denorm...

L_111G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the ftans and ftanx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	stan
	|xref	szero
	|xref	t_operr
	|xref	mon_nan
	|xref	stand

	.globl	ftans
ftans:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1122
	jbsr	stan		| normalized (regular) number
	jra	L_1126
L_1122:
	cmpb	#0x20,d0		| zero?
	jne	L_1123
	jbsr	szero
	jra	L_1126
L_1123:
	cmpb	#0x40,d0		| infinity?
	jne	L_1124
	jbsr	t_operr
	jra	L_1126
L_1124:
	cmpb	#0x60,d0		| NaN?
	jne	L_1125
	jbsr	mon_nan
	jra	L_1126
L_1125:
	jbsr	stand		| assuming a denorm...

L_1126:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	ftand
ftand:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1127
	jbsr	stan		| normalized (regular) number
	jra	L_112B
L_1127:
	cmpb	#0x20,d0		| zero?
	jne	L_1128
	jbsr	szero
	jra	L_112B
L_1128:
	cmpb	#0x40,d0		| infinity?
	jne	L_1129
	jbsr	t_operr
	jra	L_112B
L_1129:
	cmpb	#0x60,d0		| NaN?
	jne	L_112A
	jbsr	mon_nan
	jra	L_112B
L_112A:
	jbsr	stand		| assuming a denorm...

L_112B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	ftanx
ftanx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_112C
	jbsr	stan		| normalized (regular) number
	jra	L_112G
L_112C:
	cmpb	#0x20,d0		| zero?
	jne	L_112D
	jbsr	szero
	jra	L_112G
L_112D:
	cmpb	#0x40,d0		| infinity?
	jne	L_112E
	jbsr	t_operr
	jra	L_112G
L_112E:
	cmpb	#0x60,d0		| NaN?
	jne	L_112F
	jbsr	mon_nan
	jra	L_112G
L_112F:
	jbsr	stand		| assuming a denorm...

L_112G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the ftanhs and ftanhx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	stanh
	|xref	szero
	|xref	sone
	|xref	mon_nan
	|xref	stanhd

	.globl	ftanhs
ftanhs:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1132
	jbsr	stanh		| normalized (regular) number
	jra	L_1136
L_1132:
	cmpb	#0x20,d0		| zero?
	jne	L_1133
	jbsr	szero
	jra	L_1136
L_1133:
	cmpb	#0x40,d0		| infinity?
	jne	L_1134
	jbsr	sone
	jra	L_1136
L_1134:
	cmpb	#0x60,d0		| NaN?
	jne	L_1135
	jbsr	mon_nan
	jra	L_1136
L_1135:
	jbsr	stanhd		| assuming a denorm...

L_1136:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	ftanhd
ftanhd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1137
	jbsr	stanh		| normalized (regular) number
	jra	L_113B
L_1137:
	cmpb	#0x20,d0		| zero?
	jne	L_1138
	jbsr	szero
	jra	L_113B
L_1138:
	cmpb	#0x40,d0		| infinity?
	jne	L_1139
	jbsr	sone
	jra	L_113B
L_1139:
	cmpb	#0x60,d0		| NaN?
	jne	L_113A
	jbsr	mon_nan
	jra	L_113B
L_113A:
	jbsr	stanhd		| assuming a denorm...

L_113B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	ftanhx
ftanhx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_113C
	jbsr	stanh		| normalized (regular) number
	jra	L_113G
L_113C:
	cmpb	#0x20,d0		| zero?
	jne	L_113D
	jbsr	szero
	jra	L_113G
L_113D:
	cmpb	#0x40,d0		| infinity?
	jne	L_113E
	jbsr	sone
	jra	L_113G
L_113E:
	cmpb	#0x60,d0		| NaN?
	jne	L_113F
	jbsr	mon_nan
	jra	L_113G
L_113F:
	jbsr	stanhd		| assuming a denorm...

L_113G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the ftentoxs and ftentoxx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	stentox
	|xref	ld_pone
	|xref	szr_inf
	|xref	mon_nan
	|xref	stentoxd

	.globl	ftentoxs
ftentoxs:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1142
	jbsr	stentox		| normalized (regular) number
	jra	L_1146
L_1142:
	cmpb	#0x20,d0		| zero?
	jne	L_1143
	jbsr	ld_pone
	jra	L_1146
L_1143:
	cmpb	#0x40,d0		| infinity?
	jne	L_1144
	jbsr	szr_inf
	jra	L_1146
L_1144:
	cmpb	#0x60,d0		| NaN?
	jne	L_1145
	jbsr	mon_nan
	jra	L_1146
L_1145:
	jbsr	stentoxd		| assuming a denorm...

L_1146:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	ftentoxd
ftentoxd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1147
	jbsr	stentox		| normalized (regular) number
	jra	L_114B
L_1147:
	cmpb	#0x20,d0		| zero?
	jne	L_1148
	jbsr	ld_pone
	jra	L_114B
L_1148:
	cmpb	#0x40,d0		| infinity?
	jne	L_1149
	jbsr	szr_inf
	jra	L_114B
L_1149:
	cmpb	#0x60,d0		| NaN?
	jne	L_114A
	jbsr	mon_nan
	jra	L_114B
L_114A:
	jbsr	stentoxd		| assuming a denorm...

L_114B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	ftentoxx
ftentoxx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_114C
	jbsr	stentox		| normalized (regular) number
	jra	L_114G
L_114C:
	cmpb	#0x20,d0		| zero?
	jne	L_114D
	jbsr	ld_pone
	jra	L_114G
L_114D:
	cmpb	#0x40,d0		| infinity?
	jne	L_114E
	jbsr	szr_inf
	jra	L_114G
L_114E:
	cmpb	#0x60,d0		| NaN?
	jne	L_114F
	jbsr	mon_nan
	jra	L_114G
L_114F:
	jbsr	stentoxd		| assuming a denorm...

L_114G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the ftwotoxs and ftwotoxx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	stwotox
	|xref	ld_pone
	|xref	szr_inf
	|xref	mon_nan
	|xref	stwotoxd

	.globl	ftwotoxs
ftwotoxs:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1152
	jbsr	stwotox		| normalized (regular) number
	jra	L_1156
L_1152:
	cmpb	#0x20,d0		| zero?
	jne	L_1153
	jbsr	ld_pone
	jra	L_1156
L_1153:
	cmpb	#0x40,d0		| infinity?
	jne	L_1154
	jbsr	szr_inf
	jra	L_1156
L_1154:
	cmpb	#0x60,d0		| NaN?
	jne	L_1155
	jbsr	mon_nan
	jra	L_1156
L_1155:
	jbsr	stwotoxd		| assuming a denorm...

L_1156:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	ftwotoxd
ftwotoxd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1157
	jbsr	stwotox		| normalized (regular) number
	jra	L_115B
L_1157:
	cmpb	#0x20,d0		| zero?
	jne	L_1158
	jbsr	ld_pone
	jra	L_115B
L_1158:
	cmpb	#0x40,d0		| infinity?
	jne	L_1159
	jbsr	szr_inf
	jra	L_115B
L_1159:
	cmpb	#0x60,d0		| NaN?
	jne	L_115A
	jbsr	mon_nan
	jra	L_115B
L_115A:
	jbsr	stwotoxd		| assuming a denorm...

L_115B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	ftwotoxx
ftwotoxx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_115C
	jbsr	stwotox		| normalized (regular) number
	jra	L_115G
L_115C:
	cmpb	#0x20,d0		| zero?
	jne	L_115D
	jbsr	ld_pone
	jra	L_115G
L_115D:
	cmpb	#0x40,d0		| infinity?
	jne	L_115E
	jbsr	szr_inf
	jra	L_115G
L_115E:
	cmpb	#0x60,d0		| NaN?
	jne	L_115F
	jbsr	mon_nan
	jra	L_115G
L_115F:
	jbsr	stwotoxd		| assuming a denorm...

L_115G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fgetmans and fgetmanx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	sgetman
	|xref	szero
	|xref	t_operr
	|xref	mon_nan
	|xref	sgetmand

	.globl	fgetmans
fgetmans:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1162
	jbsr	sgetman		| normalized (regular) number
	jra	L_1166
L_1162:
	cmpb	#0x20,d0		| zero?
	jne	L_1163
	jbsr	szero
	jra	L_1166
L_1163:
	cmpb	#0x40,d0		| infinity?
	jne	L_1164
	jbsr	t_operr
	jra	L_1166
L_1164:
	cmpb	#0x60,d0		| NaN?
	jne	L_1165
	jbsr	mon_nan
	jra	L_1166
L_1165:
	jbsr	sgetmand		| assuming a denorm...

L_1166:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fgetmand
fgetmand:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1167
	jbsr	sgetman		| normalized (regular) number
	jra	L_116B
L_1167:
	cmpb	#0x20,d0		| zero?
	jne	L_1168
	jbsr	szero
	jra	L_116B
L_1168:
	cmpb	#0x40,d0		| infinity?
	jne	L_1169
	jbsr	t_operr
	jra	L_116B
L_1169:
	cmpb	#0x60,d0		| NaN?
	jne	L_116A
	jbsr	mon_nan
	jra	L_116B
L_116A:
	jbsr	sgetmand		| assuming a denorm...

L_116B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fgetmanx
fgetmanx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_116C
	jbsr	sgetman		| normalized (regular) number
	jra	L_116G
L_116C:
	cmpb	#0x20,d0		| zero?
	jne	L_116D
	jbsr	szero
	jra	L_116G
L_116D:
	cmpb	#0x40,d0		| infinity?
	jne	L_116E
	jbsr	t_operr
	jra	L_116G
L_116E:
	cmpb	#0x60,d0		| NaN?
	jne	L_116F
	jbsr	mon_nan
	jra	L_116G
L_116F:
	jbsr	sgetmand		| assuming a denorm...

L_116G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the flogns and flognx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	sslogn
	|xref	t_dz2
	|xref	sopr_inf
	|xref	mon_nan
	|xref	sslognd

	.globl	flogns
flogns:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1172
	jbsr	sslogn		| normalized (regular) number
	jra	L_1176
L_1172:
	cmpb	#0x20,d0		| zero?
	jne	L_1173
	jbsr	t_dz2
	jra	L_1176
L_1173:
	cmpb	#0x40,d0		| infinity?
	jne	L_1174
	jbsr	sopr_inf
	jra	L_1176
L_1174:
	cmpb	#0x60,d0		| NaN?
	jne	L_1175
	jbsr	mon_nan
	jra	L_1176
L_1175:
	jbsr	sslognd		| assuming a denorm...

L_1176:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	flognd
flognd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1177
	jbsr	sslogn		| normalized (regular) number
	jra	L_117B
L_1177:
	cmpb	#0x20,d0		| zero?
	jne	L_1178
	jbsr	t_dz2
	jra	L_117B
L_1178:
	cmpb	#0x40,d0		| infinity?
	jne	L_1179
	jbsr	sopr_inf
	jra	L_117B
L_1179:
	cmpb	#0x60,d0		| NaN?
	jne	L_117A
	jbsr	mon_nan
	jra	L_117B
L_117A:
	jbsr	sslognd		| assuming a denorm...

L_117B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	flognx
flognx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_117C
	jbsr	sslogn		| normalized (regular) number
	jra	L_117G
L_117C:
	cmpb	#0x20,d0		| zero?
	jne	L_117D
	jbsr	t_dz2
	jra	L_117G
L_117D:
	cmpb	#0x40,d0		| infinity?
	jne	L_117E
	jbsr	sopr_inf
	jra	L_117G
L_117E:
	cmpb	#0x60,d0		| NaN?
	jne	L_117F
	jbsr	mon_nan
	jra	L_117G
L_117F:
	jbsr	sslognd		| assuming a denorm...

L_117G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the flog2s and flog2x entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	sslog2
	|xref	t_dz2
	|xref	sopr_inf
	|xref	mon_nan
	|xref	sslog2d

	.globl	flog2s
flog2s:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1182
	jbsr	sslog2		| normalized (regular) number
	jra	L_1186
L_1182:
	cmpb	#0x20,d0		| zero?
	jne	L_1183
	jbsr	t_dz2
	jra	L_1186
L_1183:
	cmpb	#0x40,d0		| infinity?
	jne	L_1184
	jbsr	sopr_inf
	jra	L_1186
L_1184:
	cmpb	#0x60,d0		| NaN?
	jne	L_1185
	jbsr	mon_nan
	jra	L_1186
L_1185:
	jbsr	sslog2d		| assuming a denorm...

L_1186:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	flog2d
flog2d:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1187
	jbsr	sslog2		| normalized (regular) number
	jra	L_118B
L_1187:
	cmpb	#0x20,d0		| zero?
	jne	L_1188
	jbsr	t_dz2
	jra	L_118B
L_1188:
	cmpb	#0x40,d0		| infinity?
	jne	L_1189
	jbsr	sopr_inf
	jra	L_118B
L_1189:
	cmpb	#0x60,d0		| NaN?
	jne	L_118A
	jbsr	mon_nan
	jra	L_118B
L_118A:
	jbsr	sslog2d		| assuming a denorm...

L_118B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	flog2x
flog2x:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_118C
	jbsr	sslog2		| normalized (regular) number
	jra	L_118G
L_118C:
	cmpb	#0x20,d0		| zero?
	jne	L_118D
	jbsr	t_dz2
	jra	L_118G
L_118D:
	cmpb	#0x40,d0		| infinity?
	jne	L_118E
	jbsr	sopr_inf
	jra	L_118G
L_118E:
	cmpb	#0x60,d0		| NaN?
	jne	L_118F
	jbsr	mon_nan
	jra	L_118G
L_118F:
	jbsr	sslog2d		| assuming a denorm...

L_118G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the flog10s and flog10x entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	sslog10
	|xref	t_dz2
	|xref	sopr_inf
	|xref	mon_nan
	|xref	sslog10d

	.globl	flog10s
flog10s:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1192
	jbsr	sslog10		| normalized (regular) number
	jra	L_1196
L_1192:
	cmpb	#0x20,d0		| zero?
	jne	L_1193
	jbsr	t_dz2
	jra	L_1196
L_1193:
	cmpb	#0x40,d0		| infinity?
	jne	L_1194
	jbsr	sopr_inf
	jra	L_1196
L_1194:
	cmpb	#0x60,d0		| NaN?
	jne	L_1195
	jbsr	mon_nan
	jra	L_1196
L_1195:
	jbsr	sslog10d		| assuming a denorm...

L_1196:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	flog10d
flog10d:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1197
	jbsr	sslog10		| normalized (regular) number
	jra	L_119B
L_1197:
	cmpb	#0x20,d0		| zero?
	jne	L_1198
	jbsr	t_dz2
	jra	L_119B
L_1198:
	cmpb	#0x40,d0		| infinity?
	jne	L_1199
	jbsr	sopr_inf
	jra	L_119B
L_1199:
	cmpb	#0x60,d0		| NaN?
	jne	L_119A
	jbsr	mon_nan
	jra	L_119B
L_119A:
	jbsr	sslog10d		| assuming a denorm...

L_119B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	flog10x
flog10x:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_119C
	jbsr	sslog10		| normalized (regular) number
	jra	L_119G
L_119C:
	cmpb	#0x20,d0		| zero?
	jne	L_119D
	jbsr	t_dz2
	jra	L_119G
L_119D:
	cmpb	#0x40,d0		| infinity?
	jne	L_119E
	jbsr	sopr_inf
	jra	L_119G
L_119E:
	cmpb	#0x60,d0		| NaN?
	jne	L_119F
	jbsr	mon_nan
	jra	L_119G
L_119F:
	jbsr	sslog10d		| assuming a denorm...

L_119G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the flognp1s and flognp1x entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	sslognp1
	|xref	szero
	|xref	sopr_inf
	|xref	mon_nan
	|xref	slognp1d

	.globl	flognp1s
flognp1s:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1202
	jbsr	sslognp1		| normalized (regular) number
	jra	L_1206
L_1202:
	cmpb	#0x20,d0		| zero?
	jne	L_1203
	jbsr	szero
	jra	L_1206
L_1203:
	cmpb	#0x40,d0		| infinity?
	jne	L_1204
	jbsr	sopr_inf
	jra	L_1206
L_1204:
	cmpb	#0x60,d0		| NaN?
	jne	L_1205
	jbsr	mon_nan
	jra	L_1206
L_1205:
	jbsr	slognp1d		| assuming a denorm...

L_1206:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	flognp1d
flognp1d:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1207
	jbsr	sslognp1		| normalized (regular) number
	jra	L_120B
L_1207:
	cmpb	#0x20,d0		| zero?
	jne	L_1208
	jbsr	szero
	jra	L_120B
L_1208:
	cmpb	#0x40,d0		| infinity?
	jne	L_1209
	jbsr	sopr_inf
	jra	L_120B
L_1209:
	cmpb	#0x60,d0		| NaN?
	jne	L_120A
	jbsr	mon_nan
	jra	L_120B
L_120A:
	jbsr	slognp1d		| assuming a denorm...

L_120B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	flognp1x
flognp1x:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_120C
	jbsr	sslognp1		| normalized (regular) number
	jra	L_120G
L_120C:
	cmpb	#0x20,d0		| zero?
	jne	L_120D
	jbsr	szero
	jra	L_120G
L_120D:
	cmpb	#0x40,d0		| infinity?
	jne	L_120E
	jbsr	sopr_inf
	jra	L_120G
L_120E:
	cmpb	#0x60,d0		| NaN?
	jne	L_120F
	jbsr	mon_nan
	jra	L_120G
L_120F:
	jbsr	slognp1d		| assuming a denorm...

L_120G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fints and fintx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	l_sint
	|xref	szero
	|xref	sinf
	|xref	mon_nan
	|xref	l_sintd

	.globl	fints
fints:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1212
	jbsr	l_sint		| normalized (regular) number
	jra	L_1216
L_1212:
	cmpb	#0x20,d0		| zero?
	jne	L_1213
	jbsr	szero
	jra	L_1216
L_1213:
	cmpb	#0x40,d0		| infinity?
	jne	L_1214
	jbsr	sinf
	jra	L_1216
L_1214:
	cmpb	#0x60,d0		| NaN?
	jne	L_1215
	jbsr	mon_nan
	jra	L_1216
L_1215:
	jbsr	l_sintd		| assuming a denorm...

L_1216:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fintd
fintd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1217
	jbsr	l_sint		| normalized (regular) number
	jra	L_121B
L_1217:
	cmpb	#0x20,d0		| zero?
	jne	L_1218
	jbsr	szero
	jra	L_121B
L_1218:
	cmpb	#0x40,d0		| infinity?
	jne	L_1219
	jbsr	sinf
	jra	L_121B
L_1219:
	cmpb	#0x60,d0		| NaN?
	jne	L_121A
	jbsr	mon_nan
	jra	L_121B
L_121A:
	jbsr	l_sintd		| assuming a denorm...

L_121B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fintx
fintx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_121C
	jbsr	l_sint		| normalized (regular) number
	jra	L_121G
L_121C:
	cmpb	#0x20,d0		| zero?
	jne	L_121D
	jbsr	szero
	jra	L_121G
L_121D:
	cmpb	#0x40,d0		| infinity?
	jne	L_121E
	jbsr	sinf
	jra	L_121G
L_121E:
	cmpb	#0x60,d0		| NaN?
	jne	L_121F
	jbsr	mon_nan
	jra	L_121G
L_121F:
	jbsr	l_sintd		| assuming a denorm...

L_121G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fintrzs and fintrzx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	l_sintrz
	|xref	szero
	|xref	sinf
	|xref	mon_nan
	|xref	snzrinx

	.globl	fintrzs
fintrzs:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1222
	jbsr	l_sintrz		| normalized (regular) number
	jra	L_1226
L_1222:
	cmpb	#0x20,d0		| zero?
	jne	L_1223
	jbsr	szero
	jra	L_1226
L_1223:
	cmpb	#0x40,d0		| infinity?
	jne	L_1224
	jbsr	sinf
	jra	L_1226
L_1224:
	cmpb	#0x60,d0		| NaN?
	jne	L_1225
	jbsr	mon_nan
	jra	L_1226
L_1225:
	jbsr	snzrinx		| assuming a denorm...

L_1226:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fintrzd
fintrzd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1227
	jbsr	l_sintrz		| normalized (regular) number
	jra	L_122B
L_1227:
	cmpb	#0x20,d0		| zero?
	jne	L_1228
	jbsr	szero
	jra	L_122B
L_1228:
	cmpb	#0x40,d0		| infinity?
	jne	L_1229
	jbsr	sinf
	jra	L_122B
L_1229:
	cmpb	#0x60,d0		| NaN?
	jne	L_122A
	jbsr	mon_nan
	jra	L_122B
L_122A:
	jbsr	snzrinx		| assuming a denorm...

L_122B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fintrzx
fintrzx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_122C
	jbsr	l_sintrz		| normalized (regular) number
	jra	L_122G
L_122C:
	cmpb	#0x20,d0		| zero?
	jne	L_122D
	jbsr	szero
	jra	L_122G
L_122D:
	cmpb	#0x40,d0		| infinity?
	jne	L_122E
	jbsr	sinf
	jra	L_122G
L_122E:
	cmpb	#0x60,d0		| NaN?
	jne	L_122F
	jbsr	mon_nan
	jra	L_122G
L_122F:
	jbsr	snzrinx		| assuming a denorm...

L_122G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in USER_FPCR(a6) so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete updating of the fpsr if you only care about
|		   the result.
|		4. Remove the frems and fremx entry points if your compiler
|		   treats everything as doubles.
|		5. Move the result to d0/d1 if the compiler is that old.
|

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	prem
	|xref	tag

	.globl	frems
frems:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoves	a6@(12),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	prem

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored

	unlk	a6
	rts

	.globl	fremd
fremd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoved	a6@(16),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	prem

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fremx
fremx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmovex	a6@(20),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	prem

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in USER_FPCR(a6) so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete updating of the fpsr if you only care about
|		   the result.
|		4. Remove the fmods and fmodx entry points if your compiler
|		   treats everything as doubles.
|		5. Move the result to d0/d1 if the compiler is that old.
|

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	pmod
	|xref	tag

	.globl	fmods
fmods:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoves	a6@(12),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	pmod

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored

	unlk	a6
	rts

	.globl	fmodd
fmodd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoved	a6@(16),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	pmod

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fmodx
fmodx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmovex	a6@(20),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	pmod

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in USER_FPCR(a6) so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete updating of the fpsr if you only care about
|		   the result.
|		4. Remove the fscales and fscalex entry points if your compiler
|		   treats everything as doubles.
|		5. Move the result to d0/d1 if the compiler is that old.
|

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	pscale
	|xref	tag

	.globl	fscales
fscales:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoves	a6@(12),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	pscale

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored

	unlk	a6
	rts

	.globl	fscaled
fscaled:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoved	a6@(16),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	pscale

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fscalex
fscalex:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmovex	a6@(20),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	pscale

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fabss and fabsx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	sabs
	|xref	sabs
	|xref	sabs
	|xref	sabs
	|xref	sabs

	.globl	fabss
fabss:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1262
	jbsr	sabs		| normalized (regular) number
	jra	L_1266
L_1262:
	cmpb	#0x20,d0		| zero?
	jne	L_1263
	jbsr	sabs
	jra	L_1266
L_1263:
	cmpb	#0x40,d0		| infinity?
	jne	L_1264
	jbsr	sabs
	jra	L_1266
L_1264:
	cmpb	#0x60,d0		| NaN?
	jne	L_1265
	jbsr	sabs
	jra	L_1266
L_1265:
	jbsr	sabs		| assuming a denorm...

L_1266:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fabsd
fabsd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1267
	jbsr	sabs		| normalized (regular) number
	jra	L_126B
L_1267:
	cmpb	#0x20,d0		| zero?
	jne	L_1268
	jbsr	sabs
	jra	L_126B
L_1268:
	cmpb	#0x40,d0		| infinity?
	jne	L_1269
	jbsr	sabs
	jra	L_126B
L_1269:
	cmpb	#0x60,d0		| NaN?
	jne	L_126A
	jbsr	sabs
	jra	L_126B
L_126A:
	jbsr	sabs		| assuming a denorm...

L_126B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fabsx
fabsx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_126C
	jbsr	sabs		| normalized (regular) number
	jra	L_126G
L_126C:
	cmpb	#0x20,d0		| zero?
	jne	L_126D
	jbsr	sabs
	jra	L_126G
L_126D:
	cmpb	#0x40,d0		| infinity?
	jne	L_126E
	jbsr	sabs
	jra	L_126G
L_126E:
	cmpb	#0x60,d0		| NaN?
	jne	L_126F
	jbsr	sabs
	jra	L_126G
L_126F:
	jbsr	sabs		| assuming a denorm...

L_126G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fnegs and fnegx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	sneg
	|xref	sneg
	|xref	sneg
	|xref	sneg
	|xref	sneg

	.globl	fnegs
fnegs:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1272
	jbsr	sneg		| normalized (regular) number
	jra	L_1276
L_1272:
	cmpb	#0x20,d0		| zero?
	jne	L_1273
	jbsr	sneg
	jra	L_1276
L_1273:
	cmpb	#0x40,d0		| infinity?
	jne	L_1274
	jbsr	sneg
	jra	L_1276
L_1274:
	cmpb	#0x60,d0		| NaN?
	jne	L_1275
	jbsr	sneg
	jra	L_1276
L_1275:
	jbsr	sneg		| assuming a denorm...

L_1276:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fnegd
fnegd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1277
	jbsr	sneg		| normalized (regular) number
	jra	L_127B
L_1277:
	cmpb	#0x20,d0		| zero?
	jne	L_1278
	jbsr	sneg
	jra	L_127B
L_1278:
	cmpb	#0x40,d0		| infinity?
	jne	L_1279
	jbsr	sneg
	jra	L_127B
L_1279:
	cmpb	#0x60,d0		| NaN?
	jne	L_127A
	jbsr	sneg
	jra	L_127B
L_127A:
	jbsr	sneg		| assuming a denorm...

L_127B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fnegx
fnegx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_127C
	jbsr	sneg		| normalized (regular) number
	jra	L_127G
L_127C:
	cmpb	#0x20,d0		| zero?
	jne	L_127D
	jbsr	sneg
	jra	L_127G
L_127D:
	cmpb	#0x40,d0		| infinity?
	jne	L_127E
	jbsr	sneg
	jra	L_127G
L_127E:
	cmpb	#0x60,d0		| NaN?
	jne	L_127F
	jbsr	sneg
	jra	L_127G
L_127F:
	jbsr	sneg		| assuming a denorm...

L_127G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|
|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in d1 so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete handling of the fpsr if you only care about
|		   the result.  
|		4. Some (most?) C compilers convert all float arguments
|		   to double, and provide no support at all for extended
|		   precision so remove the fsqrts and fsqrtx entry points.
|		5. Move the result to d0/d1 if the compiler is that old.

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	tag
	|xref	ssqrt
	|xref	ssqrt
	|xref	ssqrt
	|xref	ssqrt
	|xref	ssqrt

	.globl	fsqrts
fsqrts:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1282
	jbsr	ssqrt		| normalized (regular) number
	jra	L_1286
L_1282:
	cmpb	#0x20,d0		| zero?
	jne	L_1283
	jbsr	ssqrt
	jra	L_1286
L_1283:
	cmpb	#0x40,d0		| infinity?
	jne	L_1284
	jbsr	ssqrt
	jra	L_1286
L_1284:
	cmpb	#0x60,d0		| NaN?
	jne	L_1285
	jbsr	ssqrt
	jra	L_1286
L_1285:
	jbsr	ssqrt		| assuming a denorm...

L_1286:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	.globl	fsqrtd
fsqrtd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_1287
	jbsr	ssqrt		| normalized (regular) number
	jra	L_128B
L_1287:
	cmpb	#0x20,d0		| zero?
	jne	L_1288
	jbsr	ssqrt
	jra	L_128B
L_1288:
	cmpb	#0x40,d0		| infinity?
	jne	L_1289
	jbsr	ssqrt
	jra	L_128B
L_1289:
	cmpb	#0x60,d0		| NaN?
	jne	L_128A
	jbsr	ssqrt
	jra	L_128B
L_128A:
	jbsr	ssqrt		| assuming a denorm...

L_128B:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fsqrtx
fsqrtx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmovel	fpsr,a6@(USER_FPSR)
	fmovel	fpcr,a6@(USER_FPCR)
	fmovel	fpcr,d1		| user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input argument
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)
	tstb	d0
	jne	L_128C
	jbsr	ssqrt		| normalized (regular) number
	jra	L_128G
L_128C:
	cmpb	#0x20,d0		| zero?
	jne	L_128D
	jbsr	ssqrt
	jra	L_128G
L_128D:
	cmpb	#0x40,d0		| infinity?
	jne	L_128E
	jbsr	ssqrt
	jra	L_128G
L_128E:
	cmpb	#0x60,d0		| NaN?
	jne	L_128F
	jbsr	ssqrt
	jra	L_128G
L_128F:
	jbsr	ssqrt		| assuming a denorm...

L_128G:
	fmovel	fpsr,d0		| update status register
	orb	a6@(USER_FPSR+3),d0	|add previously accrued exceptions
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in USER_FPCR(a6) so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete updating of the fpsr if you only care about
|		   the result.
|		4. Remove the fadds and faddx entry points if your compiler
|		   treats everything as doubles.
|		5. Move the result to d0/d1 if the compiler is that old.
|

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	sadd
	|xref	tag

	.globl	fadds
fadds:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoves	a6@(12),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	sadd

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored

	unlk	a6
	rts

	.globl	faddd
faddd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoved	a6@(16),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	sadd

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	faddx
faddx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmovex	a6@(20),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	sadd

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in USER_FPCR(a6) so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete updating of the fpsr if you only care about
|		   the result.
|		4. Remove the fsubs and fsubx entry points if your compiler
|		   treats everything as doubles.
|		5. Move the result to d0/d1 if the compiler is that old.
|

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	ssub
	|xref	tag

	.globl	fsubs
fsubs:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoves	a6@(12),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	ssub

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored

	unlk	a6
	rts

	.globl	fsubd
fsubd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoved	a6@(16),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	ssub

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fsubx
fsubx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmovex	a6@(20),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	ssub

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in USER_FPCR(a6) so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete updating of the fpsr if you only care about
|		   the result.
|		4. Remove the fmuls and fmulx entry points if your compiler
|		   treats everything as doubles.
|		5. Move the result to d0/d1 if the compiler is that old.
|

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	smul
	|xref	tag

	.globl	fmuls
fmuls:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoves	a6@(12),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	smul

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored

	unlk	a6
	rts

	.globl	fmuld
fmuld:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoved	a6@(16),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	smul

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fmulx
fmulx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmovex	a6@(20),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	smul

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

|	This version saves all registers that will be used by the emulation
|	routines and restores all but FP0 on exit.  The FPSR is
|	updated to reflect the result of the operation.  Return value
|	is placed in FP0 for single, double and extended results.
|	
|	The package subroutines expect the incoming FPCR to be zeroed
|	since they need extended precision to work properly.  The
|	'final' FPCR is expected in USER_FPCR(a6) so that the calculated result
|	can be properly sized and rounded.  Also, if the incoming FPCR
|	has enabled any exceptions, the exception will be taken on the
|	final fmovem in this template.
|
|	Customizations:  
|		1. Remove the movem.l at the entry and exit of
|		   each routine if your compiler treats those 
|		   registers as scratch.
|		2. Likewise, don't save FP0/FP1 if they are scratch
|		   registers.
|		3. Delete updating of the fpsr if you only care about
|		   the result.
|		4. Remove the fdivs and fdivx entry points if your compiler
|		   treats everything as doubles.
|		5. Move the result to d0/d1 if the compiler is that old.
|

|		Copyright (C) Motorola, Inc. 1991
|			All Rights Reserved
|
|	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA 
|	The copyright notice above does not evidence any  
|	actual or intended publication of such source code.

	|xref	sdiv
	|xref	tag

	.globl	fdivs
fdivs:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoves	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoves	a6@(12),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	sdiv

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored

	unlk	a6
	rts

	.globl	fdivd
fdivd:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmoved	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmoved	a6@(16),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	sdiv

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	fmoved	fp0,a6@(USER_D0)	| result goes into d0/d1 pair
	moveml	a6@(USER_D0),d0-d1
	unlk	a6
	rts

	.globl	fdivx
fdivx:
	link	a6,#-LOCAL_SIZE
	fmovemx fp2-fp3,a6@(USER_FP2)
	fmoveml fpsr/fpcr,a6@(USER_FPSR) | user's rounding mode/precision
	fmovel	#0,fpcr		| force rounding mode/prec to extended,rn
|
|	copy, convert and tag input arguments
|
	fmovex	a6@(8),fp0
	fmovex	fp0,a6@(FPTEMP)
	lea	a6@(FPTEMP),a0
	jbsr	tag
	moveb	d0,a6@(DTAG)

	fmovex	a6@(20),fp0
	fmovex	fp0,a6@(ETEMP)
	lea	a6@(ETEMP),a0
	jbsr	tag
	moveb	d0,a6@(STAG)

	jbsr	sdiv

	fmovel	fpsr,d0		| update status register
	orb	a6@(FPSR_AEXCEPT),d0	|add previously accrued exceptions
	swap	d0
	orb	a6@(FPSR_QBYTE),d0	| pickup sign of quotient byte
	swap	d0
	fmovel	d0,fpsr
|
|	Result is now in FP0
|
	fmovemx a6@(USER_FP2),fp2-fp3	| note: FP0 not restored
	unlk	a6
	rts

	|end
